package impl

import (
	"context"

	"gitlab.mashroom.com/mashroom/backend/common/generic/log"
	admin "google.golang.org/api/admin/directory/v1"
	"google.golang.org/api/gmail/v1"
	"google.golang.org/api/option"
)

func gmailWatch(gm *gmail.Service, label, topic string) {
	_, err := gm.Users.Watch("me", &gmail.WatchRequest{
		LabelIds:  []string{label},
		TopicName: topic,
	}).Do()
	if err != nil {
		log.Fatal(err)
	}
	log.Printf("Subscribed %s to %s\n", topic, label)
}

func GmailSubscribe(ctx context.Context) {
	src, err := serviceAccount(ctx, EnvSubjectId, admin.AdminDirectoryUserReadonlyScope, admin.AdminDirectoryGroupReadonlyScope, gmail.GmailReadonlyScope)
	if err != nil {
		log.Fatal(err)
	}
	gm, err := gmail.NewService(ctx, option.WithTokenSource(src))
	if err != nil {
		log.Fatal(err)
	}
	ls, err := gm.Users.Labels.List("me").Do()
	if err != nil {
		log.Fatal(err)
	}
	for _, l := range ls.Labels {
		if t, ok := EnvLabels[l.Name]; ok {
			gmailWatch(gm, l.Id, t.Topic)
		}
	}
}
